Index: /branches/numpy/anuga/shallow_water/shallow_water_ext.c
===================================================================
--- /branches/numpy/anuga/shallow_water/shallow_water_ext.c	(revision 6901)
+++ /branches/numpy/anuga/shallow_water/shallow_water_ext.c	(revision 6902)
@@ -1164,27 +1256,28 @@
       // Calculate the difference between vertex 0 of the auxiliary 
       // triangle and the centroid of triangle k
-      dq0=stage_centroid_values[k0]-stage_centroid_values[k];
+      dq0 = stage_centroid_values[k0] - stage_centroid_values[k];
       
       // Calculate differentials between the vertices 
       // of the auxiliary triangle (centroids of neighbouring triangles)
-      dq1=stage_centroid_values[k1]-stage_centroid_values[k0];
-      dq2=stage_centroid_values[k2]-stage_centroid_values[k0];
-      
+      dq1 = stage_centroid_values[k1] - stage_centroid_values[k0];
+      dq2 = stage_centroid_values[k2] - stage_centroid_values[k0];
+      
+	  inv_area2 = 1.0/area2;
       // Calculate the gradient of stage on the auxiliary triangle
       a = dy2*dq1 - dy1*dq2;
-      a /= area2;
+      a *= inv_area2;
       b = dx1*dq2 - dx2*dq1;
-      b /= area2;
+      b *= inv_area2;
       
       // Calculate provisional jumps in stage from the centroid 
       // of triangle k to its vertices, to be limited
-      dqv[0]=a*dxv0+b*dyv0;
-      dqv[1]=a*dxv1+b*dyv1;
-      dqv[2]=a*dxv2+b*dyv2;
+      dqv[0] = a*dxv0 + b*dyv0;
+      dqv[1] = a*dxv1 + b*dyv1;
+      dqv[2] = a*dxv2 + b*dyv2;
       
       // Now we want to find min and max of the centroid and the 
       // vertices of the auxiliary triangle and compute jumps 
       // from the centroid to the min and max
-      find_qmin_and_qmax(dq0,dq1,dq2,&qmin,&qmax);
+      find_qmin_and_qmax(dq0, dq1, dq2, &qmin, &qmax);
       
       // Playing with dry wet interface
@@ -1193,5 +1286,5 @@
       //if (hmin>minimum_allowed_height)
       beta_tmp = beta_w_dry + (beta_w - beta_w_dry) * hfactor;
-	
+    
       //printf("min_alled_height = %f\n",minimum_allowed_height);
       //printf("hmin = %f\n",hmin);
@@ -1199,8 +1292,10 @@
       //printf("beta_tmp = %f\n",beta_tmp);
       // Limit the gradient
-      limit_gradient(dqv,qmin,qmax,beta_tmp); 
-      
-      for (i=0;i<3;i++)
-	stage_vertex_values[k3+i]=stage_centroid_values[k]+dqv[i];
+      limit_gradient(dqv, qmin, qmax, beta_tmp); 
+      
+      //for (i=0;i<3;i++)
+      stage_vertex_values[k3+0] = stage_centroid_values[k] + dqv[0];
+	  stage_vertex_values[k3+1] = stage_centroid_values[k] + dqv[1];
+	  stage_vertex_values[k3+2] = stage_centroid_values[k] + dqv[2];
       
       
@@ -1211,27 +1306,27 @@
       // Calculate the difference between vertex 0 of the auxiliary 
       // triangle and the centroid of triangle k      
-      dq0=xmom_centroid_values[k0]-xmom_centroid_values[k];
+      dq0 = xmom_centroid_values[k0] - xmom_centroid_values[k];
       
       // Calculate differentials between the vertices 
       // of the auxiliary triangle
-      dq1=xmom_centroid_values[k1]-xmom_centroid_values[k0];
-      dq2=xmom_centroid_values[k2]-xmom_centroid_values[k0];
+      dq1 = xmom_centroid_values[k1] - xmom_centroid_values[k0];
+      dq2 = xmom_centroid_values[k2] - xmom_centroid_values[k0];
       
       // Calculate the gradient of xmom on the auxiliary triangle
       a = dy2*dq1 - dy1*dq2;
-      a /= area2;
+      a *= inv_area2;
       b = dx1*dq2 - dx2*dq1;
-      b /= area2;
+      b *= inv_area2;
       
       // Calculate provisional jumps in stage from the centroid 
       // of triangle k to its vertices, to be limited      
-      dqv[0]=a*dxv0+b*dyv0;
-      dqv[1]=a*dxv1+b*dyv1;
-      dqv[2]=a*dxv2+b*dyv2;
+      dqv[0] = a*dxv0+b*dyv0;
+      dqv[1] = a*dxv1+b*dyv1;
+      dqv[2] = a*dxv2+b*dyv2;
       
       // Now we want to find min and max of the centroid and the 
       // vertices of the auxiliary triangle and compute jumps 
       // from the centroid to the min and max
-      find_qmin_and_qmax(dq0,dq1,dq2,&qmin,&qmax);
+      find_qmin_and_qmax(dq0, dq1, dq2, &qmin, &qmax);
       //beta_tmp = beta_uh;
       //if (hmin<minimum_allowed_height)
@@ -1240,9 +1335,10 @@
 
       // Limit the gradient
-      limit_gradient(dqv,qmin,qmax,beta_tmp);
-
-      for (i=0;i<3;i++)
-	xmom_vertex_values[k3+i]=xmom_centroid_values[k]+dqv[i];
-      
+      limit_gradient(dqv, qmin, qmax, beta_tmp);
+
+      for (i=0; i < 3; i++)
+      {
+        xmom_vertex_values[k3+i] = xmom_centroid_values[k] + dqv[i];
+      }
       
       //-----------------------------------
@@ -1252,27 +1348,27 @@
       // Calculate the difference between vertex 0 of the auxiliary 
       // triangle and the centroid of triangle k
-      dq0=ymom_centroid_values[k0]-ymom_centroid_values[k];
+      dq0 = ymom_centroid_values[k0] - ymom_centroid_values[k];
       
       // Calculate differentials between the vertices 
       // of the auxiliary triangle
-      dq1=ymom_centroid_values[k1]-ymom_centroid_values[k0];
-      dq2=ymom_centroid_values[k2]-ymom_centroid_values[k0];
+      dq1 = ymom_centroid_values[k1] - ymom_centroid_values[k0];
+      dq2 = ymom_centroid_values[k2] - ymom_centroid_values[k0];
       
       // Calculate the gradient of xmom on the auxiliary triangle
       a = dy2*dq1 - dy1*dq2;
-      a /= area2;
+      a *= inv_area2;
       b = dx1*dq2 - dx2*dq1;
-      b /= area2;
+      b *= inv_area2;
       
       // Calculate provisional jumps in stage from the centroid 
       // of triangle k to its vertices, to be limited
-      dqv[0]=a*dxv0+b*dyv0;
-      dqv[1]=a*dxv1+b*dyv1;
-      dqv[2]=a*dxv2+b*dyv2;
+      dqv[0] = a*dxv0 + b*dyv0;
+      dqv[1] = a*dxv1 + b*dyv1;
+      dqv[2] = a*dxv2 + b*dyv2;
       
       // Now we want to find min and max of the centroid and the 
       // vertices of the auxiliary triangle and compute jumps 
       // from the centroid to the min and max
-      find_qmin_and_qmax(dq0,dq1,dq2,&qmin,&qmax);
+      find_qmin_and_qmax(dq0, dq1, dq2, &qmin, &qmax);
       
       //beta_tmp = beta_vh;
@@ -1280,14 +1376,16 @@
       //if (hmin<minimum_allowed_height)
       //beta_tmp = beta_vh_dry;
-      beta_tmp = beta_vh_dry + (beta_vh - beta_vh_dry) * hfactor;	
+      beta_tmp = beta_vh_dry + (beta_vh - beta_vh_dry) * hfactor;   
 
       // Limit the gradient
-      limit_gradient(dqv,qmin,qmax,beta_tmp);
+      limit_gradient(dqv, qmin, qmax, beta_tmp);
       
       for (i=0;i<3;i++)
-	ymom_vertex_values[k3+i]=ymom_centroid_values[k]+dqv[i];
-	
+      {
+        ymom_vertex_values[k3 + i] = ymom_centroid_values[k] + dqv[i];
+      }
     } // End number_of_boundaries <=1 
-    else{
+    else
+    {
 
       //==============================================
@@ -1298,33 +1396,38 @@
       
       // Find the only internal neighbour (k1?)
-      for (k2=k3;k2<k3+3;k2++){
-	// Find internal neighbour of triangle k      
-	// k2 indexes the edges of triangle k	
-      
-	if (surrogate_neighbours[k2]!=k)
-	  break;
-      }
-      
-      if ((k2==k3+3)) {
-	// If we didn't find an internal neighbour
-	PyErr_SetString(PyExc_RuntimeError, 
-			"shallow_water_ext.c: Internal neighbour not found");      
-	return -1;
-      }
-      
-      k1=surrogate_neighbours[k2];
+      for (k2 = k3; k2 < k3 + 3; k2++)
+      {
+      // Find internal neighbour of triangle k      
+      // k2 indexes the edges of triangle k   
+      
+          if (surrogate_neighbours[k2] != k)
+          {
+             break;
+          }
+      }
+      
+      if ((k2 == k3 + 3)) 
+      {
+        // If we didn't find an internal neighbour
+        PyErr_SetString(PyExc_RuntimeError, 
+                        "shallow_water_ext.c: Internal neighbour not found");      
+        return -1;
+      }
+      
+      k1 = surrogate_neighbours[k2];
       
       // The coordinates of the triangle are already (x,y). 
       // Get centroid of the neighbour (x1,y1)
-      coord_index=2*k1;
-      x1=centroid_coordinates[coord_index];
-      y1=centroid_coordinates[coord_index+1];
+      coord_index = 2*k1;
+      x1 = centroid_coordinates[coord_index];
+      y1 = centroid_coordinates[coord_index + 1];
       
       // Compute x- and y- distances between the centroid of 
       // triangle k and that of its neighbour
-      dx1=x1-x; dy1=y1-y;
+      dx1 = x1 - x; 
+      dy1 = y1 - y;
       
       // Set area2 as the square of the distance
-      area2=dx1*dx1+dy1*dy1;
+      area2 = dx1*dx1 + dy1*dy1;
       
       // Set dx2=(x1-x0)/((x1-x0)^2+(y1-y0)^2) 
@@ -1332,7 +1435,7 @@
       // respectively correspond to the x- and y- gradients 
       // of the conserved quantities
-      dx2=1.0/area2;
-      dy2=dx2*dy1;
-      dx2*=dx1;
+      dx2 = 1.0/area2;
+      dy2 = dx2*dy1;
+      dx2 *= dx1;
       
       
@@ -1342,32 +1445,37 @@
 
       // Compute differentials
-      dq1=stage_centroid_values[k1]-stage_centroid_values[k];
+      dq1 = stage_centroid_values[k1] - stage_centroid_values[k];
       
       // Calculate the gradient between the centroid of triangle k 
       // and that of its neighbour
-      a=dq1*dx2;
-      b=dq1*dy2;
+      a = dq1*dx2;
+      b = dq1*dy2;
       
       // Calculate provisional vertex jumps, to be limited
-      dqv[0]=a*dxv0+b*dyv0;
-      dqv[1]=a*dxv1+b*dyv1;
-      dqv[2]=a*dxv2+b*dyv2;
+      dqv[0] = a*dxv0 + b*dyv0;
+      dqv[1] = a*dxv1 + b*dyv1;
+      dqv[2] = a*dxv2 + b*dyv2;
       
       // Now limit the jumps
-      if (dq1>=0.0){
-	qmin=0.0;
-	qmax=dq1;
-      }
-      else{
-	qmin=dq1;
-	qmax=0.0;
+      if (dq1>=0.0)
+      {
+        qmin=0.0;
+        qmax=dq1;
+      }
+      else
+      {
+        qmin = dq1;
+        qmax = 0.0;
       }
       
       // Limit the gradient
-      limit_gradient(dqv,qmin,qmax,beta_w);
-      
-      for (i=0;i<3;i++)
-	stage_vertex_values[k3+i]=stage_centroid_values[k]+dqv[i];
-      
+      limit_gradient(dqv, qmin, qmax, beta_w);
+      
+      //for (i=0; i < 3; i++)
+      //{
+      stage_vertex_values[k3] = stage_centroid_values[k] + dqv[0];
+      stage_vertex_values[k3 + 1] = stage_centroid_values[k] + dqv[1];
+      stage_vertex_values[k3 + 2] = stage_centroid_values[k] + dqv[2];
+      //}
       
       //-----------------------------------
@@ -1376,32 +1484,40 @@
       
       // Compute differentials
-      dq1=xmom_centroid_values[k1]-xmom_centroid_values[k];
+      dq1 = xmom_centroid_values[k1] - xmom_centroid_values[k];
       
       // Calculate the gradient between the centroid of triangle k 
       // and that of its neighbour
-      a=dq1*dx2;
-      b=dq1*dy2;
+      a = dq1*dx2;
+      b = dq1*dy2;
       
       // Calculate provisional vertex jumps, to be limited
-      dqv[0]=a*dxv0+b*dyv0;
-      dqv[1]=a*dxv1+b*dyv1;
-      dqv[2]=a*dxv2+b*dyv2;
+      dqv[0] = a*dxv0+b*dyv0;
+      dqv[1] = a*dxv1+b*dyv1;
+      dqv[2] = a*dxv2+b*dyv2;
       
       // Now limit the jumps
-      if (dq1>=0.0){
-	qmin=0.0;
-	qmax=dq1;
-      }
-      else{
-	qmin=dq1;
-	qmax=0.0;
+      if (dq1 >= 0.0)
+      {
+        qmin = 0.0;
+        qmax = dq1;
+      }
+      else
+      {
+        qmin = dq1;
+        qmax = 0.0;
       }
       
       // Limit the gradient      
-      limit_gradient(dqv,qmin,qmax,beta_w);
-      
-      for (i=0;i<3;i++)
-	xmom_vertex_values[k3+i]=xmom_centroid_values[k]+dqv[i];
-      
+      limit_gradient(dqv, qmin, qmax, beta_w);
+      
+      //for (i=0;i<3;i++)
+      //xmom_vertex_values[k3] = xmom_centroid_values[k] + dqv[0];
+      //xmom_vertex_values[k3 + 1] = xmom_centroid_values[k] + dqv[1];
+      //xmom_vertex_values[k3 + 2] = xmom_centroid_values[k] + dqv[2];
+      
+      for (i = 0; i < 3;i++)
+      {
+          xmom_vertex_values[k3 + i] = xmom_centroid_values[k] + dqv[i];
+      }
       
       //-----------------------------------
@@ -1410,37 +1526,48 @@
 
       // Compute differentials
-      dq1=ymom_centroid_values[k1]-ymom_centroid_values[k];
+      dq1 = ymom_centroid_values[k1] - ymom_centroid_values[k];
       
       // Calculate the gradient between the centroid of triangle k 
       // and that of its neighbour
-      a=dq1*dx2;
-      b=dq1*dy2;
+      a = dq1*dx2;
+      b = dq1*dy2;
       
       // Calculate provisional vertex jumps, to be limited
-      dqv[0]=a*dxv0+b*dyv0;
-      dqv[1]=a*dxv1+b*dyv1;
-      dqv[2]=a*dxv2+b*dyv2;
+      dqv[0] = a*dxv0 + b*dyv0;
+      dqv[1] = a*dxv1 + b*dyv1;
+      dqv[2] = a*dxv2 + b*dyv2;
       
       // Now limit the jumps
-      if (dq1>=0.0){
-	qmin=0.0;
-	qmax=dq1;
-      }
-      else{
-	qmin=dq1;
-	qmax=0.0;
+      if (dq1>=0.0)
+      {
+        qmin = 0.0;
+        qmax = dq1;
+      } 
+      else
+      {
+        qmin = dq1;
+        qmax = 0.0;
       }
       
       // Limit the gradient
-      limit_gradient(dqv,qmin,qmax,beta_w);
-      
-      for (i=0;i<3;i++)
-	ymom_vertex_values[k3+i]=ymom_centroid_values[k]+dqv[i];
-	
+      limit_gradient(dqv, qmin, qmax, beta_w);
+      
+      //for (i=0;i<3;i++)
+      //ymom_vertex_values[k3] = ymom_centroid_values[k] + dqv[0];
+      //ymom_vertex_values[k3 + 1] = ymom_centroid_values[k] + dqv[1];
+      //ymom_vertex_values[k3 + 2] = ymom_centroid_values[k] + dqv[2];
+
+for (i=0;i<3;i++)
+        {
+ymom_vertex_values[k3 + i] = ymom_centroid_values[k] + dqv[i];
+        }
+//ymom_vertex_values[k3] = ymom_centroid_values[k] + dqv[0];
+//ymom_vertex_values[k3 + 1] = ymom_centroid_values[k] + dqv[1];
+//ymom_vertex_values[k3 + 2] = ymom_centroid_values[k] + dqv[2];
     } // else [number_of_boundaries==2]
   } // for k=0 to number_of_elements-1
   
   return 0;
-}			
+}           
 
 
@@ -1477,6 +1604,6 @@
     Post conditions:
             The vertices of each triangle have values from a 
-	    limited linear reconstruction
-	    based on centroid values
+        limited linear reconstruction
+        based on centroid values
 
   */
@@ -1505,21 +1632,21 @@
   // Convert Python arguments to C
   if (!PyArg_ParseTuple(args, "OOOOOOOOOOOOOi",
-			&domain,
-			&surrogate_neighbours,
-			&number_of_boundaries,
-			&centroid_coordinates,
-			&stage_centroid_values,
-			&xmom_centroid_values,
-			&ymom_centroid_values,
-			&elevation_centroid_values,
-			&vertex_coordinates,
-			&stage_vertex_values,
-			&xmom_vertex_values,
-			&ymom_vertex_values,
-			&elevation_vertex_values,
-			&optimise_dry_cells)) {			
-			
+            &domain,
+            &surrogate_neighbours,
+            &number_of_boundaries,
+            &centroid_coordinates,
+            &stage_centroid_values,
+            &xmom_centroid_values,
+            &ymom_centroid_values,
+            &elevation_centroid_values,
+            &vertex_coordinates,
+            &stage_vertex_values,
+            &xmom_vertex_values,
+            &ymom_vertex_values,
+            &elevation_vertex_values,
+            &optimise_dry_cells)) {         
+            
     PyErr_SetString(PyExc_RuntimeError, 
-		    "Input arguments to extrapolate_second_order_sw failed");
+            "Input arguments to extrapolate_second_order_sw failed");
     return NULL;
   }
@@ -1557,29 +1684,29 @@
   // Call underlying computational routine
   e = _extrapolate_second_order_sw(number_of_elements,
-				   epsilon,
-				   minimum_allowed_height,
-				   beta_w,
-				   beta_w_dry,
-				   beta_uh,
-				   beta_uh_dry,
-				   beta_vh,
-				   beta_vh_dry,
-				   (long*) surrogate_neighbours -> data,
-				   (long*) number_of_boundaries -> data,
-				   (double*) centroid_coordinates -> data,
-				   (double*) stage_centroid_values -> data,
-				   (double*) xmom_centroid_values -> data,
-				   (double*) ymom_centroid_values -> data,
-				   (double*) elevation_centroid_values -> data,
-				   (double*) vertex_coordinates -> data,
-				   (double*) stage_vertex_values -> data,
-				   (double*) xmom_vertex_values -> data,
-				   (double*) ymom_vertex_values -> data,
-				   (double*) elevation_vertex_values -> data,
-				   optimise_dry_cells);
+                   epsilon,
+                   minimum_allowed_height,
+                   beta_w,
+                   beta_w_dry,
+                   beta_uh,
+                   beta_uh_dry,
+                   beta_vh,
+                   beta_vh_dry,
+                   (long*) surrogate_neighbours -> data,
+                   (long*) number_of_boundaries -> data,
+                   (double*) centroid_coordinates -> data,
+                   (double*) stage_centroid_values -> data,
+                   (double*) xmom_centroid_values -> data,
+                   (double*) ymom_centroid_values -> data,
+                   (double*) elevation_centroid_values -> data,
+                   (double*) vertex_coordinates -> data,
+                   (double*) stage_vertex_values -> data,
+                   (double*) xmom_vertex_values -> data,
+                   (double*) ymom_vertex_values -> data,
+                   (double*) elevation_vertex_values -> data,
+                   optimise_dry_cells);
   if (e == -1) {
     // Use error string set inside computational routine
     return NULL;
-  }  				  
+  }                   
   
   
@@ -1609,5 +1736,5 @@
   // Convert Python arguments to C
   if (!PyArg_ParseTupleAndKeywords(args, kwargs, "OO|i", argnames,
-				   &Q, &Normal, &direction)) {
+                   &Q, &Normal, &direction)) {
     PyErr_SetString(PyExc_RuntimeError, "shallow_water_ext.c: rotate could not parse input arguments");
     return NULL;
@@ -1654,31 +1781,31 @@
 // Computational function for flux computation
 double _compute_fluxes_central(int number_of_elements,
-			       double timestep,
-			       double epsilon,
-			       double H0,
-			       double g,
-			       long* neighbours,
-			       long* neighbour_edges,
-			       double* normals,
-			       double* edgelengths, 
-			       double* radii, 
-			       double* areas,
-			       long* tri_full_flag,
-			       double* stage_edge_values,
-			       double* xmom_edge_values,
-			       double* ymom_edge_values,
-			       double* bed_edge_values,
-			       double* stage_boundary_values,
-			       double* xmom_boundary_values,
-			       double* ymom_boundary_values,
-			       double* stage_explicit_update,
-			       double* xmom_explicit_update,
-			       double* ymom_explicit_update,
-			       long* already_computed_flux,
-			       double* max_speed_array,
-			       int optimise_dry_cells) {
-			       
+                               double timestep,
+                               double epsilon,
+                               double H0,
+                               double g,
+                               long* neighbours,
+                               long* neighbour_edges,
+                               double* normals,
+                               double* edgelengths, 
+                               double* radii, 
+                               double* areas,
+                               long* tri_full_flag,
+                               double* stage_edge_values,
+                               double* xmom_edge_values,
+                               double* ymom_edge_values,
+                               double* bed_edge_values,
+                               double* stage_boundary_values,
+                               double* xmom_boundary_values,
+                               double* ymom_boundary_values,
+                               double* stage_explicit_update,
+                               double* xmom_explicit_update,
+                               double* ymom_explicit_update,
+                               long* already_computed_flux,
+                               double* max_speed_array,
+                               int optimise_dry_cells) 
+{                   
   // Local variables
-  double max_speed, length, area, zl, zr;
+  double max_speed, length, inv_area, zl, zr;
   int k, i, m, n;
   int ki, nm=0, ki2; // Index shorthands
@@ -1687,30 +1814,30 @@
   double ql[3], qr[3], edgeflux[3]; // Work array for summing up fluxes
 
-  static long call=1; // Static local variable flagging already computed flux
-			       
-	
+  static long call = 1; // Static local variable flagging already computed flux
+                   
   // Start computation
   call++; // Flag 'id' of flux calculation for this timestep 
-  
+
   // Set explicit_update to zero for all conserved_quantities.
   // This assumes compute_fluxes called before forcing terms
-  for (k=0; k<number_of_elements; k++) {
-    stage_explicit_update[k]=0.0;
-    xmom_explicit_update[k]=0.0;
-    ymom_explicit_update[k]=0.0;  
-  }
-
+  memset((char*) stage_explicit_update, 0, number_of_elements*sizeof(double));
+  memset((char*) xmom_explicit_update, 0, number_of_elements*sizeof(double));
+  memset((char*) ymom_explicit_update, 0, number_of_elements*sizeof(double));    
+  
   // For all triangles
-  for (k=0; k<number_of_elements; k++) {
-    
+  for (k = 0; k < number_of_elements; k++) 
+  {  
     // Loop through neighbours and compute edge flux for each  
-    for (i=0; i<3; i++) {
-      ki = k*3+i; // Linear index (triangle k, edge i)
+    for (i = 0; i < 3; i++) 
+    {
+      ki = k*3 + i; // Linear index to edge i of triangle k
       
       if (already_computed_flux[ki] == call)
+      {
         // We've already computed the flux across this edge
-	continue;
-	
-	
+        continue;
+      }
+    
+      // Get left hand side values from triangle k, edge i 
       ql[0] = stage_edge_values[ki];
       ql[1] = xmom_edge_values[ki];
@@ -1718,45 +1845,53 @@
       zl = bed_edge_values[ki];
 
-      // Quantities at neighbour on nearest face
+      // Get right hand side values either from neighbouring triangle
+      // or from boundary array (Quantities at neighbour on nearest face).
       n = neighbours[ki];
-      if (n < 0) {
+      if (n < 0) 
+      {
         // Neighbour is a boundary condition
-	m = -n-1; // Convert negative flag to boundary index
-	
-	qr[0] = stage_boundary_values[m];
-	qr[1] = xmom_boundary_values[m];
-	qr[2] = ymom_boundary_values[m];
-	zr = zl; // Extend bed elevation to boundary
-      } else {
-        // Neighbour is a real element
-	m = neighbour_edges[ki];
-	nm = n*3+m; // Linear index (triangle n, edge m)
-	
-	qr[0] = stage_edge_values[nm];
-	qr[1] = xmom_edge_values[nm];
-	qr[2] = ymom_edge_values[nm];
-	zr = bed_edge_values[nm];
-      }
-      
-      
-      if (optimise_dry_cells) {      
-	// Check if flux calculation is necessary across this edge
-	// This check will exclude dry cells.
-	// This will also optimise cases where zl != zr as 
-	// long as both are dry
-
-	if ( fabs(ql[0] - zl) < epsilon && 
-	     fabs(qr[0] - zr) < epsilon ) {
-	  // Cell boundary is dry
-	  
-	  already_computed_flux[ki] = call; // #k Done	
-	  if (n>=0)
-	    already_computed_flux[nm] = call; // #n Done
-	
-	  max_speed = 0.0;
-	  continue;
-	}
-      }
-    
+        m = -n - 1; // Convert negative flag to boundary index
+    
+        qr[0] = stage_boundary_values[m];
+        qr[1] = xmom_boundary_values[m];
+        qr[2] = ymom_boundary_values[m];
+        zr = zl; // Extend bed elevation to boundary
+      } 
+      else 
+      {
+        // Neighbour is a real triangle
+        m = neighbour_edges[ki];
+        nm = n*3 + m; // Linear index (triangle n, edge m)
+        
+        qr[0] = stage_edge_values[nm];
+        qr[1] = xmom_edge_values[nm];
+        qr[2] = ymom_edge_values[nm];
+        zr = bed_edge_values[nm];
+      }
+      
+      // Now we have values for this edge - both from left and right side.
+      
+      if (optimise_dry_cells) 
+      {     
+        // Check if flux calculation is necessary across this edge
+        // This check will exclude dry cells.
+        // This will also optimise cases where zl != zr as 
+        // long as both are dry
+
+        if (fabs(ql[0] - zl) < epsilon && 
+            fabs(qr[0] - zr) < epsilon) 
+        {
+          // Cell boundary is dry
+          
+          already_computed_flux[ki] = call; // #k Done  
+          if (n >= 0)
+          {
+            already_computed_flux[nm] = call; // #n Done
+          }
+        
+          max_speed = 0.0;
+          continue;
+        }
+      }
       
       // Outward pointing normal vector (domain.normals[k, 2*i:2*i+2])
@@ -1765,7 +1900,7 @@
       // Edge flux computation (triangle k, edge i)
       _flux_function_central(ql, qr, zl, zr,
-			     normals[ki2], normals[ki2+1],
-			     epsilon, H0, g,
-			     edgeflux, &max_speed);
+                             normals[ki2], normals[ki2+1],
+                             epsilon, H0, g,
+                             edgeflux, &max_speed);
       
       
@@ -1786,33 +1921,36 @@
       
       // Update neighbour n with same flux but reversed sign
-      if (n>=0) {
-	stage_explicit_update[n] += edgeflux[0];
-	xmom_explicit_update[n] += edgeflux[1];
-	ymom_explicit_update[n] += edgeflux[2];
-	
-	already_computed_flux[nm] = call; // #n Done
-      }
-
+      if (n >= 0) 
+      {
+        stage_explicit_update[n] += edgeflux[0];
+        xmom_explicit_update[n] += edgeflux[1];
+        ymom_explicit_update[n] += edgeflux[2];
+        
+        already_computed_flux[nm] = call; // #n Done
+      }
 
       // Update timestep based on edge i and possibly neighbour n
-      if (tri_full_flag[k] == 1) {
-	if (max_speed > epsilon) {
-	
-	  // Apply CFL condition for triangles joining this edge (triangle k and triangle n)
-	  
-	  // CFL for triangle k
-	  timestep = min(timestep, radii[k]/max_speed);
-	  
-	  if (n>=0) 
-	    // Apply CFL condition for neigbour n (which is on the ith edge of triangle k)
-	    timestep = min(timestep, radii[n]/max_speed);
-	  
-	  // Ted Rigby's suggested less conservative version
-	  //if (n>=0) { 	    
-	  //  timestep = min(timestep, (radii[k]+radii[n])/max_speed);
-	  //} else {
-	  //  timestep = min(timestep, radii[k]/max_speed);
-	  // }
-	}
+      if (tri_full_flag[k] == 1) 
+      {
+        if (max_speed > epsilon) 
+        {
+          // Apply CFL condition for triangles joining this edge (triangle k and triangle n)
+          
+          // CFL for triangle k
+          timestep = min(timestep, radii[k]/max_speed);
+          
+          if (n >= 0)
+          {
+            // Apply CFL condition for neigbour n (which is on the ith edge of triangle k)
+            timestep = min(timestep, radii[n]/max_speed);
+          }
+
+          // Ted Rigby's suggested less conservative version
+          //if (n>=0) {         
+          //  timestep = min(timestep, (radii[k]+radii[n])/max_speed);
+          //} else {
+          //  timestep = min(timestep, radii[k]/max_speed);
+          // }
+        }
       }
       
@@ -1822,8 +1960,8 @@
     // Normalise triangle k by area and store for when all conserved
     // quantities get updated
-    area = areas[k];
-    stage_explicit_update[k] /= area;
-    xmom_explicit_update[k] /= area;
-    ymom_explicit_update[k] /= area;
+    inv_area = 1.0/areas[k];
+    stage_explicit_update[k] *= inv_area;
+    xmom_explicit_update[k] *= inv_area;
+    ymom_explicit_update[k] *= inv_area;
     
    
@@ -1832,7 +1970,5 @@
     
   } // End triangle k
-	
-			       
-			       
+             
   return timestep;
 }
@@ -1869,30 +2005,30 @@
 
     PyObject 
-	*domain,
-	*stage, 
-	*xmom, 
-	*ymom, 
-	*bed;
+    *domain,
+    *stage, 
+    *xmom, 
+    *ymom, 
+    *bed;
 
     PyArrayObject 
-	*neighbours, 
-	*neighbour_edges,
-	*normals, 
-	*edgelengths, 
-	*radii, 
-	*areas,
-	*tri_full_flag,
-	*stage_edge_values,
-	*xmom_edge_values,
-	*ymom_edge_values,
-	*bed_edge_values,
-	*stage_boundary_values,
-	*xmom_boundary_values,
-	*ymom_boundary_values,
-	*stage_explicit_update,
-	*xmom_explicit_update,
-	*ymom_explicit_update,
-	*already_computed_flux, //Tracks whether the flux across an edge has already been computed
-	*max_speed_array; //Keeps track of max speeds for each triangle
+    *neighbours, 
+    *neighbour_edges,
+    *normals, 
+    *edgelengths, 
+    *radii, 
+    *areas,
+    *tri_full_flag,
+    *stage_edge_values,
+    *xmom_edge_values,
+    *ymom_edge_values,
+    *bed_edge_values,
+    *stage_boundary_values,
+    *xmom_boundary_values,
+    *ymom_boundary_values,
+    *stage_explicit_update,
+    *xmom_explicit_update,
+    *ymom_explicit_update,
+    *already_computed_flux, //Tracks whether the flux across an edge has already been computed
+    *max_speed_array; //Keeps track of max speeds for each triangle
 
     
@@ -1902,6 +2038,6 @@
     // Convert Python arguments to C
     if (!PyArg_ParseTuple(args, "dOOOO", &timestep, &domain, &stage, &xmom, &ymom, &bed )) {
-	PyErr_SetString(PyExc_RuntimeError, "Input arguments failed");
-	return NULL;
+    PyErr_SetString(PyExc_RuntimeError, "Input arguments failed");
+    return NULL;
     }
 
@@ -1940,28 +2076,28 @@
   // the explicit update arrays 
   timestep = _compute_fluxes_central(number_of_elements,
-				     timestep,
-				     epsilon,
-				     H0,
-				     g,
-				     (long*) neighbours -> data,
-				     (long*) neighbour_edges -> data,
-				     (double*) normals -> data,
-				     (double*) edgelengths -> data, 
-				     (double*) radii -> data, 
-				     (double*) areas -> data,
-				     (long*) tri_full_flag -> data,
-				     (double*) stage_edge_values -> data,
-				     (double*) xmom_edge_values -> data,
-				     (double*) ymom_edge_values -> data,
-				     (double*) bed_edge_values -> data,
-				     (double*) stage_boundary_values -> data,
-				     (double*) xmom_boundary_values -> data,
-				     (double*) ymom_boundary_values -> data,
-				     (double*) stage_explicit_update -> data,
-				     (double*) xmom_explicit_update -> data,
-				     (double*) ymom_explicit_update -> data,
-				     (long*) already_computed_flux -> data,
-				     (double*) max_speed_array -> data,
-				     optimise_dry_cells);
+                     timestep,
+                     epsilon,
+                     H0,
+                     g,
+                     (long*) neighbours -> data,
+                     (long*) neighbour_edges -> data,
+                     (double*) normals -> data,
+                     (double*) edgelengths -> data, 
+                     (double*) radii -> data, 
+                     (double*) areas -> data,
+                     (long*) tri_full_flag -> data,
+                     (double*) stage_edge_values -> data,
+                     (double*) xmom_edge_values -> data,
+                     (double*) ymom_edge_values -> data,
+                     (double*) bed_edge_values -> data,
+                     (double*) stage_boundary_values -> data,
+                     (double*) xmom_boundary_values -> data,
+                     (double*) ymom_boundary_values -> data,
+                     (double*) stage_explicit_update -> data,
+                     (double*) xmom_explicit_update -> data,
+                     (double*) ymom_explicit_update -> data,
+                     (long*) already_computed_flux -> data,
+                     (double*) max_speed_array -> data,
+                     optimise_dry_cells);
 
   Py_DECREF(neighbours);
@@ -2013,5 +2149,5 @@
     domain.timestep = compute_fluxes(timestep,
                                      domain.epsilon,
-				     domain.H0,
+                     domain.H0,
                                      domain.g,
                                      domain.neighbours,
@@ -2033,5 +2169,5 @@
                                      Ymom.explicit_update,
                                      already_computed_flux,
-				     optimise_dry_cells)				     
+                     optimise_dry_cells)                     
 
 
